#include "Globals.h"

#define PLAYERANIM0 0
#define PLAYERANIM1 1024
#define PLAYERANIM2 2048
#define PLAYERATTACK 4096
#define PLAYERJUMP 3072

#define ENEMYANIM0 5120
#define ENEMYANIM1 6144
#define ENEMYANIM2 7168
#define ENEMYATTACK 8192
#define ENEMYPUKE 9216

static int g_PlayerAnimFrame = 0;
static int g_EnemyAnimFrame = 0;
static int g_CandleAnimFrame = 0;
void DrawBGmap(void* image, int size16, void* map, void* Palette)
{
    //ham_SetBgMode(4);
    /*ham_LoadBGPal256(Palette);
    ham_LoadBitmap(image);
    ham_FlipBGBuffer();*/
    
    // Variables
    map_fragment_info_ptr bg; // BG pointer
    // Initialize the background palette
    ham_LoadBGPal(Palette,256);
	
    // Setup the tileset for our image
    ham_bg[0].ti = ham_InitTileSet(image,size16,1,1);
	
    // Setup the map for our image
    ham_bg[0].mi = ham_InitMapEmptySet(3,0);
    bg = ham_InitMapFragment(map,
            30,20,0,0,30,20,0);
    ham_InsertMapFragment(bg,0,0,0);
			
    // Display the background
    ham_InitBg(0,1,0,0);
}

void DrawLevel(void* image, int size16, void* map, void* Palette)
{
    //ham_SetBgMode(4);
    /*ham_LoadBGPal256(Palette);
    ham_LoadBitmap(image);
    ham_FlipBGBuffer();*/

    // Variables
    map_fragment_info_ptr bg; // BG pointer
    // Initialize the background palette
    ham_LoadBGPal(Palette,256);
	
    // Setup the tileset for our image
    ham_bg[0].ti = ham_InitTileSet(image,size16,1,1);
	
    // Setup the map for our image
    ham_bg[0].mi = ham_InitMapEmptySet(3,0);
    bg = ham_InitMapFragment(map,
            64,50,0,0,64,50,0);
    ham_InsertMapFragment(bg,0,0,0);
			
    // Display the background
    ham_InitBg(0,1,0,0);
}

void CreatePlayer(void* image,u16 mosaic,u16 hflip,
                            u16 vflip,u16 prio,u16 x, u16 y)
{
    GLOBALS.gfx.PLAYER.GraphicData = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,mosaic,hflip,vflip,
                    prio,0,x,y);
}

void UpdateSprites(int dir,int amount)
{
    int i =0;
    if (dir == UP)
    {
        //Move orb
        GLOBALS.MapOffy +=amount;
        GLOBALS.gfx.ORB.y+=amount;
        if (GLOBALS.gfx.ORB.Data >0)
        {
            MoveOrb(GLOBALS.gfx.ORB.x,GLOBALS.gfx.ORB.y);
        }
        for (i =0; i<3; ++i)
        {
            GLOBALS.gfx.ENEMY[i].y+=amount;
            if (GLOBALS.gfx.ENEMY[i].Data >0)
            {
                MoveEnemy(i,GLOBALS.gfx.ENEMY[i].x,GLOBALS.gfx.ENEMY[i].y,
                        GLOBALS.gfx.ENEMY[i].dir);
            }
        }
        for (i =0; i<10; ++i)
        {
            GLOBALS.gfx.Puke[i].y+=amount;
            if (GLOBALS.gfx.Puke[i].Data >0)
            {
                MovePuke(i,GLOBALS.gfx.Puke[i].x,GLOBALS.gfx.Puke[i].y,
                        GLOBALS.gfx.Puke[i].dir);
            }
        }
    }
    else if(dir == DOWN)
    {
        GLOBALS.MapOffy -=amount;
        //Move orb
        GLOBALS.gfx.ORB.y-=amount;
        if (GLOBALS.gfx.ORB.Data >0)
        {
            MoveOrb(GLOBALS.gfx.ORB.x,GLOBALS.gfx.ORB.y);
        }
        for (i =0; i<3; ++i)
        {
            GLOBALS.gfx.ENEMY[i].y-=amount;
            if (GLOBALS.gfx.ENEMY[i].Data >0)
            {
                MoveEnemy(i,GLOBALS.gfx.ENEMY[i].x,GLOBALS.gfx.ENEMY[i].y,
                        GLOBALS.gfx.ENEMY[i].dir);
            }
        }
        for (i =0; i<10; ++i)
        {
            GLOBALS.gfx.Puke[i].y-=amount;
            if (GLOBALS.gfx.Puke[i].Data >0)
            {
                MovePuke(i,GLOBALS.gfx.Puke[i].x,GLOBALS.gfx.Puke[i].y,
                        GLOBALS.gfx.Puke[i].dir);
            }
        }
    }
    else if(dir == LEFT)
    {
        GLOBALS.MapOffx +=amount;
        //Move orb
        GLOBALS.gfx.ORB.x+=amount;
        if (GLOBALS.gfx.ORB.Data >0)
        {
            MoveOrb(GLOBALS.gfx.ORB.x,GLOBALS.gfx.ORB.y);
        }
        for (i =0; i<3; ++i)
        {
            GLOBALS.gfx.ENEMY[i].x+=amount;
            GLOBALS.gfx.ENEMY[i].ix+=amount;
            if (GLOBALS.gfx.ENEMY[i].Data >0)
            {
                MoveEnemy(i,GLOBALS.gfx.ENEMY[i].x,GLOBALS.gfx.ENEMY[i].y,
                        GLOBALS.gfx.ENEMY[i].dir);
            }
        }
        for (i =0; i<10; ++i)
        {
            GLOBALS.gfx.Puke[i].x+=amount;
            if (GLOBALS.gfx.Puke[i].Data >0)
            {
                MovePuke(i,GLOBALS.gfx.Puke[i].x,GLOBALS.gfx.Puke[i].y,
                        GLOBALS.gfx.Puke[i].dir);
            }
        }
    }
    else if(dir == RIGHT)
    {
        GLOBALS.MapOffx -=amount;
        //Move orb
        GLOBALS.gfx.ORB.x-=amount;
        if (GLOBALS.gfx.ORB.Data >0)
        {
            MoveOrb(GLOBALS.gfx.ORB.x,GLOBALS.gfx.ORB.y);
        }
        for (i =0; i<3; ++i)
        {
            GLOBALS.gfx.ENEMY[i].x-=amount;
            GLOBALS.gfx.ENEMY[i].ix-=amount;
            if (GLOBALS.gfx.ENEMY[i].Data >0)
            {
                MoveEnemy(i,GLOBALS.gfx.ENEMY[i].x,GLOBALS.gfx.ENEMY[i].y,
                        GLOBALS.gfx.ENEMY[i].dir);
            }
        }
        for (i =0; i<10; ++i)
        {
            GLOBALS.gfx.Puke[i].x-=amount;
            if (GLOBALS.gfx.Puke[i].Data >0)
            {
                MovePuke(i,GLOBALS.gfx.Puke[i].x,GLOBALS.gfx.Puke[i].y,
                        GLOBALS.gfx.Puke[i].dir);
            }
        }
    }
}

void MoveOrb(int x, int y)
{
    ham_SetObjXY(GLOBALS.gfx.ORB.Data,x,y);
}

void AnimatePlayer(const unsigned char* image)
{
    
    if (GLOBALS.gfx.PLAYER.State == WALK)
    {
        if(GLOBALS.PlayerAnimation >= 2)
        {
            ++g_PlayerAnimFrame;
            if(g_PlayerAnimFrame >3)
            {
                g_PlayerAnimFrame =0;
            }
            GLOBALS.PlayerAnimation = 0;

        }
        
        if (g_PlayerAnimFrame == 0)
        {
            ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)image);
        }
        else if (g_PlayerAnimFrame == 1)
        {
            ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)&image[PLAYERANIM1]);
        }
        else if (g_PlayerAnimFrame == 2)
        {
            ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)image);
        }
        else if (g_PlayerAnimFrame == 3)
        {
            ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)&image[PLAYERANIM2]);
        }
    }
    else if(GLOBALS.gfx.PLAYER.State == ATTACK)
    {
        ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)&image[PLAYERATTACK]);
    }
    else if(GLOBALS.gfx.PLAYER.State == WAIT)
    {
        ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)image);
    }
    else if(GLOBALS.gfx.PLAYER.State == JUMP)
    {
        ham_UpdateObjGfx(GLOBALS.gfx.PLAYER.GraphicData, (void*)&image[PLAYERJUMP]);
    }
}

void CreateOrb(void* image, int x, int y)
{
    GLOBALS.gfx.ORB.Data = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,0,0,0,
                    0,0,x,y);
}
void CreateHP(void* image, int x, int y, char num)
{
    if (num == 1)
    {
        GLOBALS.gfx.hp.HP1 = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,x,y);
    }
    else if (num == 2)
    {
        GLOBALS.gfx.hp.HP2 = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,x,y);
    }
    else if (num == 3)
    {
        GLOBALS.gfx.hp.HP3 = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,x,y);
    }
    else if (num == 4)
    {
        GLOBALS.gfx.hp.HP4 = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,x,y);
    }
    else if (num == 5)
    {
        GLOBALS.gfx.hp.HP5 = ham_CreateObj(image,0,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,x,y);
    }
}

void UpdateHP(void)
{
    if (GLOBALS.gfx.PLAYER.Health == 4)
    {
        ham_DeleteObj(GLOBALS.gfx.hp.HP5);
    }
    if (GLOBALS.gfx.PLAYER.Health == 3)
    {
        ham_DeleteObj(GLOBALS.gfx.hp.HP4);
    }
    if (GLOBALS.gfx.PLAYER.Health == 2)
    {
        ham_DeleteObj(GLOBALS.gfx.hp.HP3);
    }
    if (GLOBALS.gfx.PLAYER.Health == 1)
    {
        ham_DeleteObj(GLOBALS.gfx.hp.HP2);
    }
    if (GLOBALS.gfx.PLAYER.Health == 0)
    {
        ham_DeleteObj(GLOBALS.gfx.hp.HP1);
        //Dead
        ++GLOBALS.GameState;
    }
}

void CreateEnemy(int index, const unsigned char* image,u16 hflip,u16 x, u16 y)
{
    GLOBALS.gfx.ENEMY[index].Data = ham_CreateObj((void*)&image[ENEMYANIM0],0,2,
                    OBJ_MODE_NORMAL,1,0,0,hflip,0,0,0,x,y);
}

void AnimateEnemy(const unsigned char* image)
{
    int i = 0, j =0;
    for(i=0;i<3;++i)
    {
        if (GLOBALS.gfx.ENEMY[i].State == EWALK)
        {
            if(GLOBALS.EnemyAnimation >= 2)
            {
                ++g_EnemyAnimFrame;
                if(g_EnemyAnimFrame >3)
                {
                    g_EnemyAnimFrame =0;
                }
                GLOBALS.EnemyAnimation = 0;

            }
            if (GLOBALS.gfx.ENEMY[i].Alive)
            {
                if (g_EnemyAnimFrame == 0)
                {
                    ham_UpdateObjGfx(GLOBALS.gfx.ENEMY[i].Data, (void*)&image[ENEMYANIM0]);
                }
                else if (g_EnemyAnimFrame == 1)
                {
                    ham_UpdateObjGfx(GLOBALS.gfx.ENEMY[i].Data, (void*)&image[ENEMYANIM1]);
                }
                else if (g_EnemyAnimFrame == 2)
                {
                    ham_UpdateObjGfx(GLOBALS.gfx.ENEMY[i].Data, (void*)&image[ENEMYANIM0]);
                }
                else if (g_EnemyAnimFrame == 3)
                {
                    ham_UpdateObjGfx(GLOBALS.gfx.ENEMY[i].Data, (void*)&image[ENEMYANIM2]);
                }
            }
        }
        else
        {
            ham_UpdateObjGfx(GLOBALS.gfx.ENEMY[i].Data, (void*)&image[ENEMYATTACK]);
            for(j = 0;j<10;++j)
            {
                if(GLOBALS.gfx.ENEMY[i].x > 0 && GLOBALS.gfx.ENEMY[i].y > 0){
                    if(GLOBALS.gfx.Puke[j].Alive == FALSE)
                    {
                        //GLOBALS.gfx.ENEMY[i].State = EWALK;
                        GLOBALS.gfx.Puke[j].Alive = TRUE;
                        GLOBALS.gfx.Puke[j].dir = GLOBALS.gfx.ENEMY[i].dir;
                        GLOBALS.gfx.Puke[j].y = GLOBALS.gfx.ENEMY[i].y;
                        if (GLOBALS.gfx.Puke[j].dir == 1)
                        {
                            GLOBALS.gfx.Puke[j].dir = 0;
                            GLOBALS.gfx.Puke[j].x = GLOBALS.gfx.ENEMY[i].x;
                        }
                        else
                        {
                            GLOBALS.gfx.Puke[j].dir = 1;
                            GLOBALS.gfx.Puke[j].x = GLOBALS.gfx.ENEMY[i].x+32;
                        }
                        CreatePuke(j,(void*)&image[ENEMYPUKE],GLOBALS.gfx.Puke[j].dir,
                            GLOBALS.gfx.Puke[j].x,GLOBALS.gfx.Puke[j].y);
                            break;
                    }
                }
            }
        }
    }
}
void AnimatePuke(void)
{
    int i =0;
    if(GLOBALS.NewFrame)
    {
        for(i=0;i<10;++i)
        {
            if(GLOBALS.gfx.Puke[i].Alive)
            {
                if (GLOBALS.gfx.Puke[i].dir == 1)
                {
                    --GLOBALS.gfx.Puke[i].x;
                    if (GLOBALS.gfx.Puke[i].x <=0)
                    {
                        ham_DeleteObj(GLOBALS.gfx.Puke[i].Data);
                        GLOBALS.gfx.Puke[i].Alive = FALSE;
                    }
                }
                else
                {
                    ++GLOBALS.gfx.Puke[i].x;
                    if (GLOBALS.gfx.Puke[i].x >=240)
                    {
                        ham_DeleteObj(GLOBALS.gfx.Puke[i].Data);
                        GLOBALS.gfx.Puke[i].Alive = FALSE;
                    }
                }
                MovePuke(i,GLOBALS.gfx.Puke[i].x,GLOBALS.gfx.Puke[i].y,GLOBALS.gfx.Puke[i].dir);
            }
        }
    }
}

void MovePuke(int index,int x, int y, int dir)
{
    ham_SetObjXY(GLOBALS.gfx.Puke[index].Data,x,y);
    ham_SetObjHFlip(GLOBALS.gfx.Puke[index].Data,dir);
}

void CreatePuke(int index, void* image,u16 hflip,u16 x, u16 y)
{
    GLOBALS.gfx.Puke[index].Data = ham_CreateObj(image,0,2,
                    OBJ_MODE_NORMAL,1,0,0,hflip,0,0,0,x,y);
}

void SpawnFloor2(const unsigned char* image)
{
    if(GLOBALS.gfx.PLAYER.y <=80 && GLOBALS.SpawnFloor2 == FALSE)
    {
        GLOBALS.SpawnFloor2 = TRUE;
        //GLOBALS.gfx.ENEMY[2].Alive = TRUE;
    }
    
    if(GLOBALS.SpawnFloor2 == TRUE)
    {
        if (GLOBALS.gfx.ENEMY[2].Alive == TRUE && GLOBALS.gfx.ENEMY[2].Data ==0)
        {
            if(GLOBALS.gfx.ENEMY[2].x > 0 && GLOBALS.gfx.ENEMY[2].y > 0)
            {
                //Spawn Enemy
            }
        }
        if (GLOBALS.gfx.ORB.Alive == TRUE && GLOBALS.gfx.ORB.Data ==0)
        {
            if(GLOBALS.gfx.ORB.x > 0 && GLOBALS.gfx.ORB.y > 0)
            {
                //Spawn Orb
                //CreateOrb((void*)&image[ORBANIM], GLOBALS.gfx.ORB.x,GLOBALS.gfx.ORB.y);
                ham_SetObjVisible(GLOBALS.gfx.ORB.Data,1);
                MoveOrb(16,16);
            }
        }
    }
}

void AnimateBGTiles(void)
{
    if(GLOBALS.NewFrame)
    {

        if(GLOBALS.CandleAnimation >= 2)
        {
            ++g_CandleAnimFrame;
            if(g_CandleAnimFrame >1)
            {
                g_CandleAnimFrame =0;
            }
            GLOBALS.CandleAnimation = 0;
        }


        if (g_CandleAnimFrame == 0)
        {
            ham_SetMapTile(0,5,34,0x0004);
            ham_SetMapTile(0,12,45,0x0004);
            ham_SetMapTile(0,22,45,0x0004);
            ham_SetMapTile(0,31,45,0x0004);
            ham_SetMapTile(0,46,45,0x0004);
            ham_SetMapTile(0,48,20,0x0004);
            ham_SetMapTile(0,31,20,0x0004);
        }
        else if (g_CandleAnimFrame == 1)
        {
            ham_SetMapTile(0,5,34,0x0003);
            ham_SetMapTile(0,12,45,0x0003);
            ham_SetMapTile(0,22,45,0x0003);
            ham_SetMapTile(0,31,45,0x0003);
            ham_SetMapTile(0,46,45,0x0003);
            ham_SetMapTile(0,48,20,0x0003);
            ham_SetMapTile(0,31,20,0x0003);
        }
    }
}

u8 CollisionWalls(int x, int y)
{
    int xTile = (x+GLOBALS.ScrX)>>3;
    int yTile = 0;
    u16 TileNum = 0;
    
    yTile = (y+GLOBALS.ScrY)>>3;
    TileNum=ham_GetMapTile(0,xTile,yTile);
    if (TileNum == 0x0000 || TileNum == 0x0002)
    {
        return TRUE;
    }
    
    return FALSE;
}
u8 CollisionFloor(int x, int y)
{
    int xTile = 0;
    int yTile = (y+GLOBALS.ScrY)>>3;
    u16 TileNum = 0;
    
    xTile = (x+GLOBALS.ScrX)>>3;
    TileNum=ham_GetMapTile(0,xTile,yTile);
    if (TileNum == 0x0000 || TileNum == 0x0002)
    {
        return TRUE;
    }

    return FALSE;
}

void Gravity(void)
{
    if (GLOBALS.NewFrame)
    {
        --GLOBALS.gfx.PLAYER.JumpVector;
        if (GLOBALS.gfx.PLAYER.JumpVector <0)
        {
            //Going down
            if(!CollisionFloor(GLOBALS.gfx.PLAYER.x+16,GLOBALS.gfx.PLAYER.y +32))
            {
                if(GLOBALS.gfx.PLAYER.y <=60)
                {
                    ++GLOBALS.gfx.PLAYER.y;
                    MovePlayer(GLOBALS.gfx.PLAYER.x,GLOBALS.gfx.PLAYER.y,GLOBALS.gfx.PLAYER.dir);
                }
                else
                {
                    //MoveScreen
                    if(GLOBALS.ScrY + SCR_HEIGHT < MAP_HEIGHT)
                    {
                        ++GLOBALS.ScrY;
                        ham_SetBgXY(0,GLOBALS.ScrX,GLOBALS.ScrY);
                        UpdateSprites(DOWN,1);
                    }
                    else
                    {
                        ++GLOBALS.gfx.PLAYER.y;
                        MovePlayer(GLOBALS.gfx.PLAYER.x,GLOBALS.gfx.PLAYER.y,GLOBALS.gfx.PLAYER.dir);
                    }
                }
                
            }
            else
            {
                GLOBALS.gfx.PLAYER.JumpVector =0;
                if (GLOBALS.gfx.PLAYER.State == JUMP)
                    GLOBALS.gfx.PLAYER.State = WAIT;
            }
        }
        else
        {
            //Going up
            if(!CollisionFloor(GLOBALS.gfx.PLAYER.x+16,GLOBALS.gfx.PLAYER.y))
            {
                --GLOBALS.gfx.PLAYER.y;
                if(GLOBALS.gfx.PLAYER.y >=60)
                {
                    --GLOBALS.gfx.PLAYER.y;
                    MovePlayer(GLOBALS.gfx.PLAYER.x,GLOBALS.gfx.PLAYER.y,GLOBALS.gfx.PLAYER.dir);
                }
                else
                {
                    //MoveScreen
                    if(GLOBALS.ScrY > 0)
                    {
                        --GLOBALS.ScrY;
                        ham_SetBgXY(0,GLOBALS.ScrX,GLOBALS.ScrY);
                        UpdateSprites(UP,1);
                    }
                    else
                    {
                        --GLOBALS.gfx.PLAYER.y;
                        MovePlayer(GLOBALS.gfx.PLAYER.x,GLOBALS.gfx.PLAYER.y,GLOBALS.gfx.PLAYER.dir);
                    }
                }
            }
            else
            {
                GLOBALS.gfx.PLAYER.JumpVector =0;
            }
        }
    }
}
