#ifndef GRAPHICS_H
#define GRAPHICS_H
#include <mygba.h>
#include "Player.h"
#include "Enemies.h"
//#include <vector>
enum ScrDir
{
    UP,
    DOWN,
    LEFT,
    RIGHT
};
struct Orb
{
    u8 Data;
    int x;
    int y;
    int Alive;
};
struct HPPieces
{
    u8 HP1;
    u8 HP2;
    u8 HP3;
    u8 HP4;
    u8 HP5;
};
struct Projectile
{
    u8 Data;
    int x;
    int y;
    int dir;
    int Alive;
};
//Graphics Handler using HAM
struct Graphics
{
    struct Player PLAYER; //Player sprite data
    struct Orb ORB;
    struct HPPieces hp;
    //Enemies array
    struct Enemy ENEMY[3];
    struct Projectile Puke[10];
};

void DrawBGmap(void* image, int size16, void* map, void* Palette);
void DrawLevel(void* image, int size16, void* map, void* Palette);
void CreatePlayer(void* image,u16 mosaic,u16 hflip,u16 vflip,u16 prio,u16 x, u16 y);
void AnimatePlayer(const unsigned char* image);
void UpdateSprites(int dir,int amount);
void MoveOrb(int x, int y);
void CreateOrb(void* image, int x, int y);
void CreateHP(void* image, int x, int y, char num);
void UpdateHP(void);
void CreateEnemy(int index, const unsigned char* image,u16 hflip,u16 x, u16 y);
void AnimateEnemy(const unsigned char* image);
void AnimatePuke(void);
void MovePuke(int index,int x, int y, int dir);
void CreatePuke(int index, void* image,u16 hflip,u16 x, u16 y);
void SpawnFloor2(const unsigned char* image);
void AnimateBGTiles(void);
u8 CollisionWalls(int x, int y);
u8 CollisionFloor(int x, int y);
void Gravity(void);
#endif
