#include "Globals.h"

void MovePlayer(int x, int y, int dir)
{
    ham_SetObjXY (GLOBALS.gfx.PLAYER.GraphicData, x,y);
    ham_SetObjHFlip(GLOBALS.gfx.PLAYER.GraphicData,dir);
                    
}

void SpriteCollision(void)
{
    int i=0;
    if (GLOBALS.gfx.PLAYER.State != ATTACK)
    {
        for(i =0;i<3;++i)
        {
            if (GLOBALS.gfx.ENEMY[i].Alive)
            {
                if(PlayerOnEnemy(i))
                {
                    if(GLOBALS.gfx.PLAYER.Invin == 0)
                    {
                        --GLOBALS.gfx.PLAYER.Health;
                        GLOBALS.gfx.PLAYER.Invin = 1;
                    }
                }
            }
        }
        for(i =0;i<10;++i)
        {
            if (GLOBALS.gfx.Puke[i].Alive)
            {
                if(PlayerOnPuke(i))
                {
                    //Puke dies
                    GLOBALS.gfx.Puke[i].Alive = FALSE;
                    ham_DeleteObj(GLOBALS.gfx.Puke[i].Data);
                    if(GLOBALS.gfx.PLAYER.Invin == 0)
                    {
                        --GLOBALS.gfx.PLAYER.Health;
                        GLOBALS.gfx.PLAYER.Invin = 1;
                    }
                }
            }
        }
    }
    else
    {
        for(i =0;i<3;++i)
        {
            if (GLOBALS.gfx.ENEMY[i].Alive)
            {
                if(PlayerOnEnemy(i))
                {
                    //Enemy dies
                    GLOBALS.gfx.ENEMY[i].Alive = FALSE;
                    ham_DeleteObj(GLOBALS.gfx.ENEMY[i].Data);
                }
            }
        }
        
        for(i =0;i<10;++i)
        {
            if (GLOBALS.gfx.Puke[i].Alive)
            {
                if(PlayerOnPuke(i))
                {
                    //Puke dies
                    GLOBALS.gfx.Puke[i].Alive = FALSE;
                    ham_DeleteObj(GLOBALS.gfx.Puke[i].Data);
                }
            }
        }
    }
    
    if(PlayerOnOrb())
    {
        GLOBALS.gfx.ORB.Alive = FALSE;
        ++GLOBALS.GameState;
    }
}

u8 PlayerOnEnemy(int EnemyIndex)
{
    int left1, left2;
    int right1, right2;
    int top1, top2;
    int bottom1, bottom2;

    left1 = GLOBALS.gfx.PLAYER.x+10;
    left2 = GLOBALS.gfx.ENEMY[EnemyIndex].x+10;
    right1 = GLOBALS.gfx.PLAYER.x+22;
    right2 = GLOBALS.gfx.ENEMY[EnemyIndex].x+22;
    top1 = GLOBALS.gfx.PLAYER.y;
    top2 = GLOBALS.gfx.ENEMY[EnemyIndex].y;
    bottom1 = GLOBALS.gfx.PLAYER.y+32;
    bottom2 = GLOBALS.gfx.ENEMY[EnemyIndex].x+32;

    if (bottom1 < top2) return(0);
    if (top1 > bottom2) return(0);
    if (right1 < left2) return(0);
    if (left1 > right2) return(0);
    return(1);
};

u8 PlayerOnPuke(int Index)
{
    int left1, left2;
    int right1, right2;
    int top1, top2;
    int bottom1, bottom2;

    left1 = GLOBALS.gfx.PLAYER.x+10;
    left2 = GLOBALS.gfx.Puke[Index].x+10;
    right1 = GLOBALS.gfx.PLAYER.x+22;
    right2 = GLOBALS.gfx.Puke[Index].x+22;
    top1 = GLOBALS.gfx.PLAYER.y;
    top2 = GLOBALS.gfx.Puke[Index].y;
    bottom1 = GLOBALS.gfx.PLAYER.y+32;
    bottom2 = GLOBALS.gfx.Puke[Index].x+16;

    if (bottom1 < top2) return(0);
    if (top1 > bottom2) return(0);
    if (right1 < left2) return(0);
    if (left1 > right2) return(0);
    return(1);
};

u8 PlayerOnOrb(void)
{
    int left1, left2;
    int right1, right2;
    int top1, top2;
    int bottom1, bottom2;

    left1 = GLOBALS.gfx.PLAYER.x+10;
    left2 = GLOBALS.gfx.ORB.x+10;
    right1 = GLOBALS.gfx.PLAYER.x+22;
    right2 = GLOBALS.gfx.ORB.x+22;
    top1 = GLOBALS.gfx.PLAYER.y;
    top2 = GLOBALS.gfx.ORB.y+10;
    bottom1 = GLOBALS.gfx.PLAYER.y+32;
    bottom2 = GLOBALS.gfx.ORB.x+22;

    if (bottom1 < top2) return(0);
    if (top1 > bottom2) return(0);
    if (right1 < left2) return(0);
    if (left1 > right2) return(0);
    return(1);
};
