#include "Globals.h"
#include "Images\sprites.raw.c"
#include "Images\sprites.pal.c"
#include "Images\bgtiles.raw.c"
#include "Images\bgtiles.pal.c"
#include "Images\bgtiles.map.c"


//#include "Sound\BGM.c"
//MULTIBOOT
void GameSetup(void);
void GameLoop(void);
void CleanUp(void);

void Processing(void);
int main(void)
{
   ham_Init();
   ham_StartIntHandler(INT_TYPE_VBL,(void*)&VBlank);
   ham_StartIntHandler(INT_TYPE_HBL,(void*)&HBlank);
    //GLOBALS.NewFrame = 1;
    //GLOBALS.GameState=0;
    //GLOBALS->GetSound().LoadSample((u8*)BGM_DATA,BGM_LENGTH,BGM_SAMPRATE);
    //GLOBALS->GetSound().PlaySample();
    SetupGlobals();
    while (TRUE)
    {
        Processing();
    }

   return 0;
}

void Processing(void)
{
    if (GLOBALS.GameState == 0)
    {
        MenuSetup();
    }
    if (GLOBALS.GameState == 1)
    {
        MenuProc();
    }
    if (GLOBALS.GameState == 2)
    {
        GLOBALS.GameState += FadeBG();
    }
    if (GLOBALS.GameState == 3)
    {
        StorySetup();
    }
    if (GLOBALS.GameState == 4)
    {
        StoryProc();
    }
    //Set up Game
    if (GLOBALS.GameState == 5)
    {
        GameSetup();
    }
    if (GLOBALS.GameState == 6)
    {
        GameLoop();
    }
    if (GLOBALS.GameState == 7)
    {
        CleanUp();
    }
    if (GLOBALS.GameState == 8)
    {
        //Win/Lose
        EndingSetup();
    }
    if (GLOBALS.GameState == 9)
    {
        //Win/Lose
        EndingProc();
    }
}
void GameSetup(void)
{
    ham_SetBgMode(0);
    DrawLevel((void*)bgtiles_Tiles, SIZEOF_16BIT(bgtiles_Tiles),(void*)bgtiles_Map,
                (void*)bgtiles_Palette);
    ham_SetBgXY(0,GLOBALS.ScrX,GLOBALS.ScrY);
    
    ham_LoadObjPal256((void*)sprites_Palette);
    CreatePlayer((void*)sprites_Bitmap,0,0,0,0,9,120);
    CreateOrb((void*)&sprites_Bitmap[ORBANIM], 16,16);
    //ham_SetObjVisible(GLOBALS.gfx.ORB.Data,0);
    CreateHP((void*)&sprites_Bitmap[HP], 1,0,1);
    CreateHP((void*)&sprites_Bitmap[HP], 13,0,2);
    CreateHP((void*)&sprites_Bitmap[HP], 25,0,3);
    CreateHP((void*)&sprites_Bitmap[HP], 37,0,4);
    CreateHP((void*)&sprites_Bitmap[HP], 49,0,5);
    //Create 1st floor enemies
    CreateEnemy(0,sprites_Bitmap, GLOBALS.gfx.ENEMY[0].dir,GLOBALS.gfx.ENEMY[0].x,
                GLOBALS.gfx.ENEMY[0].y);
    CreateEnemy(1,sprites_Bitmap, GLOBALS.gfx.ENEMY[1].dir,GLOBALS.gfx.ENEMY[1].x,
                GLOBALS.gfx.ENEMY[1].y);
    //UpdateSprites(DOWN,230);*/
    /*NOTE: Create Objs only when they are appearing on the Screen
    Delete them when they are off
    */
    ++GLOBALS.GameState;
}

void GameLoop(void)
{
    ProcessInput();
    AnimatePlayer(sprites_Bitmap);
    AnimateEnemy(sprites_Bitmap);
    AnimateBGTiles();
    EnemyAI();
    AnimatePuke();
    SpriteCollision();
    UpdateHP();
    Gravity();
    SpawnFloor2(sprites_Bitmap);
}

void CleanUp(void)
{
    ham_ResetBg();
    ham_ResetObj();
    ham_SetBgXY(0,0,0);
    ++GLOBALS.GameState;
}
/* END OF FILE */

